#ifndef _eventlogH
#define _eventlogH

#include "util.h"

#define CONFIGFILE			"../etc/eventlog.conf"
#define HTMLFILE			"eventlog.html"

#define EVENTLOG_ERROR_TYPE             1
#define EVENTLOG_WARNING_TYPE           2
#define EVENTLOG_INFORMATION_TYPE       4
#define EVENTLOG_AUDIT_SUCCESS          8
#define EVENTLOG_AUDIT_FAILURE          10

struct EventLogLimits
{	
	int			wAudF;
	int			eAudF;
	int			wAudS;
	int			eAudS;
	int			wErr;
	int			eErr;
	int			wWarn;
	int			eWarn;
	int			wInf;
	int			eInf;
};

int CheckState(char *buffer);

int ReadConfigData( char*			dir,
					int				&logSize,
					char* 			cName, 
					char* 			ip,
					int				&port, 
					int 			&period, 
					bool 			&applog,
					bool 			&syslog,
					bool 			&seclog,
					EventLogLimits* lim);					
int GenerateHtml(char *buffer, int period, int maxSize) ;
void WriteDateAndTime(ofstream* stream);



bool _Receive( int 			&sockfd, 
			  const SA_IN 	*servaddr, 
			  char* 		ibuf, 
			  int 			ibufSize, 
			  char* 		buffer, 
			  int 			bufferSize, 
			  int 			nMsg);

bool FindLine(ifstream* file, char* str, char* buffer, int &lineNo);
bool ReadPeriod(ifstream* file, char* buffer, char* cName, int &period, int &lineNo);
bool ReadPort(ifstream* file, char* buffer, char* cName, int &port, int &lineNo);
bool ReadIPadr(ifstream* file, char* buffer, char* cName, char* ip, int &lineNo);
bool ReadComputerName(ifstream* file, char* buffer, char*  cName, int &lineNo);
bool ReadLogValues(ifstream* file, char* buffer, int &lineNo, bool& applog, bool& syslog, bool& seclog);
bool ReadLimits(ifstream* file, char* buffer, EventLogLimits* lim, int &lineNo);
bool ReadLimits2(ifstream* file, char* buffer, char* str, int &warn, int &err, int &lineNo);

#endif