#ifndef _utilH
#define _utilH

#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <time.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <stdlib.h>
#include <sys/errno.h>
#include <signal.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>

#define SA					struct sockaddr
#define SA_IN				struct sockaddr_in
#define STATE_OK			0
#define STATE_WARNING		1
#define STATE_CRITICAL		2
#define STATE_UNKNOWN	    -1
#define BUF_SIZE			1000 // don't fuck with this, has to be equal on both the client and server
#define SOCKET_TIMEOUT		1000	 // seconds
#define PASSWDFILE			"../etc/ntpasswd"
#define MAX_PASSWD_LEN		19 
#define SRV_CHECK_QUERY		12

// Service status codes 
#define	SERV_SERVICE_DOES_NOT_EXIST		1	// The specified service does not exist.
#define	SERV_SERVICE_NOT_ACTIVE			2	// The service has not been started. 
#define	SERV_SERVICE_REQUEST_TIMEOUT	3	// The service did not respond to the request.
#define	SERV_CHECK_ERROR				4	// Something went wrong ??
#define	SERV_PAUSED						5	// The service is paused.
#define SERV_RUNNING					6	// The service is running. 

//
//  FUNCTION: void SocketTimeoutHandler(int signal)
//
//  PURPOSE: Exit program if a timeout occurs
//
//  PARAMETERS:
//    signal - timout signal     
//
//  RETURN VALUES:
//	  none
//
void SocketTimeoutHandler(int);

//
//  FUNCTION: int  ChkPasswd(char *passwd,int &passwdLen)
//
//  PURPOSE: Read password from password-file
//
//  PARAMETERS:
//    passwd - string to contain the password
//	  passwdLen - lenght of password
//  RETURN VALUES:
//	  STATE_CRITICAL - password could not be read
//	  STATE_OK - success
//
int  ChkPasswd(char *passwd,int &passwdLen);

//
//  FUNCTION: bool Send(int &sockfd, char *obuf)
//
//  PURPOSE: Send a message to the receiver
//
//  PARAMETERS:
//    sockfd - socket descriptor of the connection
//	  obuf - buffer to send
//  RETURN VALUES:
//	  true - success
//	  false - error in sending
//
bool Send(int &sockfd, char *obuf);

//
//  FUNCTION: bool Send(int &sockfd, char *obuf)
//
//  PURPOSE: Receive a message
//
//  PARAMETERS:
//    sockfd - socket descriptor of the connection
//	  
//  RETURN VALUES:
//	  buffer with message received.
//	  This buffer is created dynamically (with new) inside the function, so
//	  make sure to delete this buffer when you are finished using it
//
char* Receive(int &sockfd);

#endif