#include	"netutil.h"

DWORD WINAPI TCP_Connection( LPVOID pParam )
{		
	int			res;
	int			adrLen = sizeof(SA);
	SOCKET		listenSock;
	SOCKET		comSock;
	SA_IN		myAdr;
	SA_IN		cliAdr;
	WSADATA		WSAData;
	char		*ibuf=0;
	DWORD		msgBufSize = BUF_SIZE;
	char		*msgBuf = new char[msgBufSize];	
	int			index;

	if((res=WSAStartup(MAKEWORD(1,1),&WSAData))!=0)
	{		
		sprintf(ibuf, "Err: WSAStartup: %d", res); 
		PrintToFile(ibuf, TCPLOG);	
		return 0;
	}

	// create listening socket
	listenSock = socket(AF_INET, SOCK_STREAM, 0);

	myAdr.sin_family		= AF_INET;
	myAdr.sin_port			= htons(servPort);
	myAdr.sin_addr.s_addr	= INADDR_ANY;

	if(res=bind(listenSock, (SA*) &myAdr, adrLen)==SOCKET_ERROR)
	{
		sprintf(ibuf, "Err: bind: %d", WSAGetLastError()); 
		PrintToFile(ibuf, TCPLOG);
		return 0;
	}

	// start listening socket
	if(res =listen(listenSock, SOMAXCONN)==SOCKET_ERROR)
	{
		sprintf(ibuf, "Err: listen: %d", WSAGetLastError()); 
		PrintToFile(ibuf, TCPLOG);
		return 0;
	}

	while(1)
	{
		comSock=accept(listenSock, (SA*) &cliAdr, &adrLen);

		if(comSock==INVALID_SOCKET)
		{
			sprintf(ibuf, "Err: accept: %d", WSAGetLastError()); 
			PrintToFile(ibuf, TCPLOG);
			return 0;
		}
		
		index=0;		
		ibuf=0;
		ibuf = Receive(comSock);	

		if(ibuf!=0)	// message received
		{			
			// analayze message
			res = AnalyzeTCPMessage(ibuf, msgBuf, msgBufSize, passwd);			

			if(res == ERR_BUFFER_TOO_SMALL) {						
				delete msgBuf;
				msgBuf=new char[msgBufSize];					
				res = AnalyzeTCPMessage(ibuf, msgBuf, msgBufSize, passwd);				
			}			
			
			if(res != NOERR) {
				// if error in message, discard it and continue listening
				AddToMessageLog("ERR: Analyze() in TCP thread", EVENTLOG_ERROR_TYPE);
				PrintToFile("ERR: Analyze()", TCPLOG);
				continue;
			}			
			
			delete ibuf;
			
			cout << "\nSENDING:\n" << msgBuf << endl;			
			
			if(!Send(comSock, msgBuf))
				cout << "ERR: Send()" << endl;		
		}
		

		if(msgBufSize > BUF_SIZE)
		{
			msgBufSize=BUF_SIZE;			
			delete msgBuf;
			msgBuf = new char[BUF_SIZE];
		}	

		// break connection
		res = closesocket(comSock);
		if(res==SOCKET_ERROR)
		{					
			sprintf(ibuf, "Err: closesocket: %d", WSAGetLastError()); 
			PrintToFile(ibuf, TCPLOG);
			return 0;
		}
	}

	delete msgBuf;
	return 0;
}

int AnalyzeTCPMessage(char *ibuf, char *msgBuf, DWORD &msgBufSize, char *passwd) {
		
	int	err;
	int	id;	
	int	index=0;

	// get message id
	while(strncmp(&ibuf[index], "id=",3)!=0 && index<BUF_SIZE)
		index++;

	index+=3;
	id = atoi(&ibuf[index]);

	// check password
	if(!CheckPasswd(ibuf, passwd))
		return ERR_AUTHENTICATION;
	
	err = NOERR;

	switch( id ) 
	{	
	case EVENTLOG_QUERY:	
		if( !CheckEventLog(ibuf, msgBuf, msgBufSize ) )
			return ERR_BUFFER_TOO_SMALL;	
		return NOERR;
	case SERVICECHECK_QUERY:
		if( !CheckServices(ibuf, msgBuf, msgBufSize ))
			return ERR_BUFFER_TOO_SMALL;		
		return NOERR;
	default:
		return ERR_NO_SUCH_MESSAGE;		
	}	
}

bool CheckPasswd(char *ibuf, char *passwd)
{	
	DWORD i1=0;
	DWORD i2;

	while( strncmp(&ibuf[i1], "key=", 4)!=0 && i1 < strlen(ibuf))		
		i1++;

	i1 += 4;
	i2  = i1;
	
	while( ibuf[i2] != '\n' && i2 < strlen(ibuf) )
		i2++;

	if(strlen(passwd) != (i2-i1))
		return false;

	//cout << &ibuf[i1] << "=" << passwd << endl;
	//cout << strlen(passwd) << endl;
	
	
	if( strncmp(passwd, &ibuf[i1], strlen(passwd)) != 0)
		return false;

	//cout << "passwd: " << &ibuf[i1] << endl;
	return true;
}

bool Send(SOCKET sock, char *buffer)
{	
	int  n;
	int  index=0;
	int  nBytesToSend = strlen(buffer);
	char obuf[BUF_SIZE+1];
	char in;
	
	while(nBytesToSend>0)
	{
		strncpy(obuf, &buffer[index*BUF_SIZE], BUF_SIZE);			
		obuf[BUF_SIZE]='\0';				
		index++;

		n = send(sock, obuf, strlen(obuf), 0);
		
		//cout << "\nOBUF:\n"  << obuf << endl;
				
		if(n==SOCKET_ERROR)
		{					
			sprintf(obuf, "Err: send: %d", WSAGetLastError()); 
			PrintToFile(obuf, TCPLOG);
			return 0;
		}		
		
		nBytesToSend -= n;
		
		if(nBytesToSend <= 0)
			return 1;		
    
		n = recv( sock, &in, 1, 0);	
		
		if(n==0)	// client terminated connection
		{
			shutdown(sock, 1);
			PrintToFile("Client terminated connection", TCPLOG);
			return 1;
		}

		if( n < 0 ) 
	    {    	
	    	sprintf(obuf, "Err: recv: %d", WSAGetLastError()); 
			PrintToFile(obuf, TCPLOG);
			return 0;
	    }
	}	
	
	return 1;
}

char* Receive(SOCKET sock)			   
{
	int 	index = 0; 
	int		nBytesRecv=0;
    int 	n;        
    char  	ch='1';
    bool	ret=false;
    char	*ibuf = new char[BUF_SIZE+1];
    char 	*buffer=0;
    
    int		nBytes;	    
     	     	
    memset(ibuf,0, BUF_SIZE);
	n = recv( sock, ibuf, BUF_SIZE, 0);
	ibuf[n]='\0';
	nBytesRecv = n;

	if(n==SOCKET_ERROR)	// connection lost
	{
		sprintf(ibuf, "Err: recv: %d", WSAGetLastError()); 
		PrintToFile(ibuf, TCPLOG);
		ret=0;
		goto cleanup;
	}

	if(n==0)	// client terminated connection
	{
		shutdown(sock, 1);
		ret=0;
		goto cleanup;
	}    
	
	if( strncmp(ibuf, "nbytes=", 7) == 0)
	{
    	nBytes = atoi(&ibuf[7]);
    	
    	if( nBytes < BUF_SIZE )
    	{
    		ibuf[strlen(ibuf)]='\0';  		
    		return ibuf;    	
    	}
    		
    	buffer = new char[nBytes];    	
    	strncpy(buffer, ibuf, nBytes);      	  		
    }
    else    	
    	return ibuf;
    
    
    while(1)
    {    	
    	// tell that we are ready to receive next message
    	n = send(sock, &ch, 1, 0);

		if(n==SOCKET_ERROR)
		{					
			sprintf(ibuf, "Err: send: %d", WSAGetLastError()); 
			PrintToFile(ibuf, TCPLOG);
			return 0;
		}
		
		// wait for next message
    	memset(ibuf,0, BUF_SIZE);
    	//cout << "Waiting..." << endl;
		n = recv( sock, ibuf, BUF_SIZE, 0);

		if(n==0)	// client terminated connection
		{
			shutdown(sock, 1);
			PrintToFile("Client terminated connection", TCPLOG);
			ret=0;
			goto cleanup;
		}

		if( n < 0 ) 
	    {    	
	    	sprintf(ibuf, "Err: recv: %d", WSAGetLastError()); 
			PrintToFile(ibuf, TCPLOG);
			ret=0;
			goto cleanup;
	    }

		ibuf[n]='\0';
		nBytesRecv += n;
		strncat(buffer, ibuf, n);   			
		  	
	    
	    while( index < nBytesRecv && nBytesRecv < nBytes)
	    {
	    	if( strncmp(&buffer[index], ";;", 2) == 0)
	    	{
	    		buffer[index+2]='\0';
				goto cleanup;	    		
	    	}
	    	
	    	index++;
	    	
	    	if(nBytes < index)
	    	{
				PrintToFile("Error in Receive", TCPLOG);		
	    		ret=0;
				goto cleanup;
	    	}
	    }	    
	}

cleanup:	
	delete ibuf;
	
	return buffer;
}
