// NSServGUIDlg.cpp : implementation file
//
#include "stdafx.h"
#include "NSServGUI.h"
#include "NSServGUIDlg.h"

#include <string.h>
#include "err.h"
#include "Thread.h"
#include "Common.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Global members used to communicate with the CheckStatus-thread
SERVICE_STATUS	status;
BOOL			ChkStatThrd=true;
BOOL			isInstalled=false;
BOOL			thrdIsRunning=false;
HANDLE			hChkStatThrdEvent;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNSServGUIDlg dialog

CNSServGUIDlg::CNSServGUIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNSServGUIDlg::IDD, pParent), change(0), exit(0)
{
	//{{AFX_DATA_INIT(CNSServGUIDlg)
	m_key = _T("");
	m_port = 0;
	m_szStatus = _T("");
	m_startupType = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNSServGUIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNSServGUIDlg)
	DDX_Text(pDX, IDC_EDIT_KEY, m_key);
	DDV_MaxChars(pDX, m_key, 19);
	DDX_Text(pDX, IDC_EDIT_PORT, m_port);
	DDV_MinMaxInt(pDX, m_port, 1025, 65535);
	DDX_Text(pDX, IDC_STATUS, m_szStatus);
	DDX_Radio(pDX, IDC_RADIO1, m_startupType);
	//}}AFX_DATA_MAP
	
}

BEGIN_MESSAGE_MAP(CNSServGUIDlg, CDialog)
	//{{AFX_MSG_MAP(CNSServGUIDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_START, OnBtnStart)
	ON_BN_CLICKED(IDC_BTN_PAUSE, OnBtnPause)
	ON_BN_CLICKED(IDC_BTN_STOP, OnBtnStop)
	ON_EN_SETFOCUS(IDC_EDIT_PORT, OnSetfocusEditPort)
	ON_BN_CLICKED(IDC_BTN_INSTALL, OnBtnInstall)
	ON_BN_CLICKED(IDC_BTN_REMOVE, OnBtnRemove)
	ON_BN_CLICKED(IDC_BTN_CONTINUE, OnBtnContinue)
	ON_BN_CLICKED(IDC_BTN_APPLY, OnBtnApply)
	ON_EN_CHANGE(IDC_EDIT_KEY, OnChangeEditKey)
	ON_EN_CHANGE(IDC_EDIT_PORT, OnChangeEditPort)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_EN_KILLFOCUS(IDC_EDIT_PORT, OnKillfocusEditPort)
	ON_EN_KILLFOCUS(IDC_EDIT_KEY, OnKillfocusEditKey)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_STATUS_CHANGED, OnStatusChanged)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNSServGUIDlg message handlers

BOOL CNSServGUIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here	
	UINT		winDirSize;

	// get buffersize

	winDirSize = GetWindowsDirectory(m_winDir, 0);
	m_winDir = new char[winDirSize+20];

	// get windows directory

	if(GetWindowsDirectory(m_winDir, winDirSize) == 0)
		AfxMessageBox("Error: GetWindowsDirectory");

	strncpy(iniFileLoc, m_winDir, 256);
	strncat(iniFileLoc, "\\", 256);
	strncat(iniFileLoc, INIFILE, 256);

	// check for necessary files
	
	if(!CheckFiles())
		CDialog::OnCancel();

	// create an event so we can synchronize the CheckServiceStatus thread
	
	hChkStatThrdEvent = CreateEvent( NULL,
									 TRUE,		// manual reset
									 FALSE,		// not signaled
									 NULL );


	// start the CheckServiceStatus thread
	
	hChkStatThrd = CreateThread( NULL,
								 0,
								 (LPTHREAD_START_ROUTINE) CheckServiceStatus,
								 this,								 
								 0,
								 &dwChkStatThrdID );
	

	// get pointers to the dialog controls

	m_btnStart		= (CButton*) GetDlgItem(IDC_BTN_START);
	m_btnStop		= (CButton*) GetDlgItem(IDC_BTN_STOP);
	m_btnPause		= (CButton*) GetDlgItem(IDC_BTN_PAUSE);
	m_btnContinue	= (CButton*) GetDlgItem(IDC_BTN_CONTINUE);
	m_btnInstall	= (CButton*) GetDlgItem(IDC_BTN_INSTALL);
	m_btnRemove		= (CButton*) GetDlgItem(IDC_BTN_REMOVE);
	m_btnApply		= (CButton*) GetDlgItem(IDC_BTN_APPLY);
	
	m_btnManual		= (CButton*) GetDlgItem(IDC_RADIO1);
	m_btnAutomatic	= (CButton*) GetDlgItem(IDC_RADIO2);
	m_btnDisable	= (CButton*) GetDlgItem(IDC_RADIO3);
	
	m_pKey			= (CEdit*) GetDlgItem(IDC_EDIT_KEY);
	m_pPort			= (CEdit*) GetDlgItem(IDC_EDIT_PORT);
	
	
	// wait a little so the thread can update the 'isInstalled' member
	
	Sleep(100);

	// get configuration data for the service

	if(isInstalled)	
		GetServiceConfig();
		

	// open NSServ.ini and read the values
	
	int err;
	err = ReadInitData(key, m_port);
	if(	err != 0) {

		// the file doesn't exist or the fileformat is bad

		if(err == 2)
			AfxMessageBox("Error in fileformat");

		strcpy(key,"");		
		m_port=0;
	}

	m_key = key;
	oldPort = m_port;
	
	// update the dialog controls
	
	UpdateControls();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNSServGUIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNSServGUIDlg::OnPaint() {	
	
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNSServGUIDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CNSServGUIDlg::OnBtnStart() 
{
	// TODO: Add your control notification handler code here

	// Check if the portnumber is valid and a key is present
	UpdateData(1);
	
	char _port[10];
	itoa(m_port, _port, 10);

	if(m_port<1025 || m_port>65355)
		return;
	
	if(strlen(m_key)==0) {
		::MessageBox( NULL, "Please enter a key", SZSERVMANNAME, MB_OK | MB_ICONWARNING | MB_TASKMODAL);
		m_pKey->SetFocus();
		m_pKey->SetSel(0,strlen(m_key));
		return;
	}


	SC_HANDLE			schService;
    SC_HANDLE			schSCManager; 

    schSCManager = OpenSCManager( NULL,						// machine (NULL == local)
								  NULL,						// database (NULL == default)
								  SC_MANAGER_ALL_ACCESS );  // access required
								 
    if ( schSCManager ) {
	
		schService = OpenService( schSCManager,			// SCM database 
								  TEXT(SZSERVICENAME),  // service name
								  SERVICE_ALL_ACCESS); 
		
		if (schService == NULL) {
			LastErrorMsgBox(); 
			goto cleanup;
		}
	
		// try to start service 
		if (!StartService( schService,  // handle to service 
						   0,           // number of arguments 
						   NULL) ) {    // no arguments 
		
			LastErrorMsgBox();
			goto cleanup;
		}		
			
	} //if ( schSCManager )
	else		
		LastErrorMsgBox();

cleanup:
	if(schSCManager != NULL)
		CloseServiceHandle(schSCManager);
	if(schService != NULL)
		CloseServiceHandle(schService);
	
}

void CNSServGUIDlg::OnBtnPause() 
{
	// TODO: Add your control notification handler code here	
	::MessageBox( NULL, "Not implemented yet", SZSERVMANNAME, MB_OK | MB_ICONINFORMATION | MB_TASKMODAL); 

	
}

void CNSServGUIDlg::OnBtnStop() 
{
	// TODO: Add your control notification handler code here
	SC_HANDLE			schService;
    SC_HANDLE			schSCManager;
	SERVICE_STATUS		ssStatus;

	schSCManager = OpenSCManager( NULL,						// machine (NULL == local)
								  NULL,						// database (NULL == default)
								  SC_MANAGER_ALL_ACCESS );  // access required
 
	if ( schSCManager ) {
		// Open a handle to the service.  
		schService = OpenService( schSCManager,        // SCManager database 
								  TEXT(SZSERVICENAME), // name of service 
								  SERVICE_STOP
								| SERVICE_QUERY_STATUS);  // specify access 
		
		if (schService == NULL) {
			LastErrorMsgBox(); 
			goto cleanup;
		}
 
		// Send a stop signal to the service.  
		if (! ControlService( schService,			// handle of service 
							  SERVICE_CONTROL_STOP, // control value to send 
							  &ssStatus) )  {	    // address of status info     
			LastErrorMsgBox();
			goto cleanup;
		}
		
	} //if (schSCManager)
	else
		LastErrorMsgBox();

cleanup:
	if(schSCManager != NULL)
		CloseServiceHandle(schSCManager);
	if(schService != NULL)
		CloseServiceHandle(schService);
}

int CNSServGUIDlg::ReadInitData(char *passwd, int &port)
{
	HANDLE		hFile;		
	int			forts=0;
	int			nLoop=0;
	char		_port[5];
	int			strSize=100;
	char*		str = new char[strSize];
		
	
	hFile = CreateFile( iniFileLoc, 
						GENERIC_READ,
						0,
						NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL,
						NULL );
	
	if(hFile == INVALID_HANDLE_VALUE) {		
		return 1;
	}

	do {
		ReadLine(str, strSize, hFile);
		if( strcmp(str,"key=") == 0 ) {			
			ReadLine(passwd, strSize, hFile);
			forts++;
		}
		else if( strcmp(str,"port=") == 0) {
			ReadLine(_port, strSize, hFile);
			port = atoi(_port);
			forts++;
		}

		nLoop++;				
	}	
	while(forts<2 && nLoop<1000); 
	
	delete str;
	
	if(nLoop==1000) {		
		CloseHandle(hFile);
		return 2; //Filformat error			
	}

	CloseHandle(hFile);	
	return 0;//NOERR;
}

int CNSServGUIDlg::ReadLine(char *str, int strSize, HANDLE hFile)
{
	int index=0, err;
	char ch=' ', forrige=' ';
	DWORD nRead;
	bool eof=false;
	bool br=false;

	while(index < strSize) {
		forrige=ch;
		err= ReadFile( hFile,
					   &ch,
					   1,
			           &nRead,
				       NULL);

		str[index++]=ch;

		if( (err==1 && nRead==0) ) { // End of file
			str[index-1]='\0';
			return 0;
		}

		if( ch=='\x0a' && forrige=='\x0d') { // End of line
			str[index-2]='\0';
			return 0;			
		}
		
		if( ch=='=' ) {
			str[index]='\0';			
			return 0;
		}		
	}

	return 1; //ERROR
}

void CNSServGUIDlg::OnSetfocusEditPort() 
{
	// TODO: Add your control notification handler code here	
}

void CNSServGUIDlg::OnCancel() 
{
	// TODO: Add your control notification handler code here
	// Stop the CheckServiceStatus thread if it is running
	exit=true;

	if( hChkStatThrd != NULL) {
		ChkStatThrd=false;
		// Tell the thread that we want to exit
		SetEvent(hChkStatThrdEvent);
		// Wait for the thread to exit
		WaitForSingleObject(hChkStatThrdEvent, 5000);
	}
		
	Cleanup();

	CDialog::OnCancel();
}

void CNSServGUIDlg::OnOK() 
{	
	char		_port[5];

	UpdateData(true);	
	
	itoa(m_port, _port, 10);

	if(m_port<1025 || m_port>65355)
		return;

	if(strlen(m_key)==0) {
		AfxMessageBox("Key value missing");
		m_pKey->SetFocus();
		m_pKey->SetSel(0,strlen(m_key));
		return;
	}

	// File ha changed
	if(change) {
		int ret = AfxMessageBox("Save changes?", MB_YESNOCANCEL | MB_ICONQUESTION);
		
		if( ret == IDCANCEL)
			return;

		if( ret == IDNO) {	
			CDialog::OnOK();
			return;
		}	
	}
	
	ApplyChanges();
	

	if( hChkStatThrd != NULL) {
		ChkStatThrd=false;		
		SetEvent(hChkStatThrdEvent);		
		WaitForSingleObject(hChkStatThrdEvent, 500);
	}
		
	Cleanup();
	CDialog::OnOK();
}



void CNSServGUIDlg::OnBtnInstall() 
{	
	// TODO: Add your control notification handler code here	

	SC_HANDLE   schService;
    SC_HANDLE   schSCManager;
	LPTSTR		lpszBuf=NULL; 
	DWORD		dwStartupType;

	DWORD		dwSize=256;
	char*		szPath=0;
	DWORD		szPathLen;
	char*		appName=SZAPPNAME;
	char		str[256];

	szPathLen = GetCurrentDirectory(0, szPath);
	szPath = new char[szPathLen+strlen(appName)];
	GetCurrentDirectory(szPathLen, szPath);
	
	strncat(szPath,"\\",1);
	strncat(szPath, appName, szPathLen+strlen(appName));	
	
    schSCManager = OpenSCManager(
                        NULL,                   // machine (NULL == local)
                        NULL,                   // database (NULL == default)
                        SC_MANAGER_ALL_ACCESS   // access required
                        );
    if ( schSCManager )
    {
		
		switch(m_startupType)
		{
		case 0:
			dwStartupType = SERVICE_DEMAND_START;
			break;
		case 1:
			dwStartupType = SERVICE_AUTO_START;
			break;
		default:
			dwStartupType = SERVICE_DISABLED;
		}

        schService = CreateService(
            schSCManager,               // SCManager database
            TEXT(SZSERVICENAME),        // name of service
            TEXT(SZSERVICEDISPLAYNAME), // name to display
            SERVICE_ALL_ACCESS,         // desired access
            SERVICE_WIN32_OWN_PROCESS,  // service type
            dwStartupType,				// start type
            SERVICE_ERROR_NORMAL,       // error control type
            szPath,                     // service's binary
            NULL,                       // no load ordering group
            NULL,                       // no tag identifier
            TEXT(SZDEPENDENCIES),       // dependencies
            NULL,                       // LocalSystem account
            NULL);                      // no password

        if ( schService )
        {            			
            CloseServiceHandle(schService);			
			strncpy(str, SZSERVICEDISPLAYNAME, 256);
			strncat(str, " successfully installed", 256);
			
			isInstalled=true;
			UpdateControls();
		
			::MessageBox( NULL, str, SZSERVMANNAME, MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);		

			if(!thrdIsRunning) {
				CloseServiceHandle(schSCManager);
				
				//AfxMessageBox("hChckStatThr == NULL");
				// Start the CheckServiceStatus trhread
				
				hChkStatThrd =   CreateThread( NULL,
								 0,
								 (LPTHREAD_START_ROUTINE) CheckServiceStatus,
								 this,
								 0,
								 &dwChkStatThrdID );				
				return;
			}			
        }
		else 			
			LastErrorMsgBox();					

        CloseServiceHandle(schSCManager);
    }
	else{		
		LastErrorMsgBox();			
	}
}

void CNSServGUIDlg::OnBtnRemove() 
{
	SC_HANDLE			schService;
    SC_HANDLE			schSCManager;
	SERVICE_STATUS		ssStatus;
	char				str[256];

	
    schSCManager = OpenSCManager(
                        NULL,                   // machine (NULL == local)
                        NULL,                   // database (NULL == default)
                        SC_MANAGER_ALL_ACCESS   // access required
                        );
    if ( schSCManager )
    {
        schService = OpenService(schSCManager, TEXT(SZSERVICENAME), SERVICE_ALL_ACCESS);

        if (schService)
        {
            // try to stop the service
            if ( ControlService( schService, SERVICE_CONTROL_STOP, &ssStatus ) ) {                
                Sleep( 1000 );

                while( QueryServiceStatus( schService, &ssStatus ) ) {
                    if ( ssStatus.dwCurrentState == SERVICE_STOP_PENDING )                                            
                        Sleep( 1000 );				
                    else
                        break;
				}

            }

            // now remove the service
            if( DeleteService(schService) ) {
				CloseServiceHandle(schService);			
				strncpy(str, SZSERVICEDISPLAYNAME, 256);
				strncat(str, " successfully removed", 256);
				
				isInstalled=false;
				UpdateControls();
				::MessageBox( NULL, str, SZSERVMANNAME, MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);

				// stop the CheckServiceStatus thread and wait for it to exit
				
				ChkStatThrd = false;
				SetEvent(hChkStatThrdEvent);
				WaitForSingleObject(hChkStatThrdEvent, INFINITE);				
				
				CloseHandle(hChkStatThrd);
				hChkStatThrd = NULL;
								
				m_szStatus = "Not installed";
				UpdateData(0);
            }
			else
				LastErrorMsgBox();

            CloseServiceHandle(schService);
        } // if (schService)
        else
			LastErrorMsgBox();			

        CloseServiceHandle(schSCManager);
    } // if (schSCManager)
    else
		LastErrorMsgBox();        	
}


void CNSServGUIDlg::OnStatusChanged(WPARAM wParam, LPARAM lParam) {
	UpdateControls();
}

void CNSServGUIDlg::Cleanup()
{	
	CloseHandle(hChkStatThrd);
	CloseHandle(hChkStatThrdEvent);	

}

void CNSServGUIDlg::OnBtnContinue() 
{
	// TODO: Add your control notification handler code here
	
	::MessageBox( NULL, "Not implemented yet", SZSERVMANNAME, MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
}

void CNSServGUIDlg::OnBtnApply() 
{
	// TODO: Add your control notification handler code here
	ApplyChanges();
	change=false;
	m_btnApply->EnableWindow(0);
}

void CNSServGUIDlg::ApplyChanges()
{

	HANDLE		hFile;		
	int			forts=0;
	int			nLoop=0;
	char		_port[5];
	DWORD		bufSize=500;
	char*		buf;
	char*		dir=0;
	DWORD		nWritten;
	DWORD		dirlen;	

	dirlen = GetCurrentDirectory(0, dir);
	dir = new char[dirlen];

	if(dirlen > bufSize)
		bufSize=dirlen;

	buf = new char[bufSize];
	
	if(GetCurrentDirectory(dirlen, dir)==0) {
		AfxMessageBox("Error reading directory");
		return;
	}

	UpdateData(true);	
	itoa(m_port, _port, 10);

	if(m_port<1025 || m_port>65355)
		AfxMessageBox("Invalid port");

	// File has changed
	if( m_port!=oldPort || strcmp(m_key, key)!=0) {
		
		hFile = CreateFile( iniFileLoc, 
							GENERIC_WRITE,
							0,
							NULL,
							CREATE_ALWAYS,
							FILE_ATTRIBUTE_NORMAL,
							NULL );
		
		if(hFile == INVALID_HANDLE_VALUE) {
			AfxMessageBox("Error creating file");
			CloseHandle(hFile);
			return;
		}			

		strncpy(buf, "key=", bufSize );
		strncat(buf, m_key,  bufSize );
		strncat(buf, "\r\nport=", bufSize );
		strncat(buf, _port,  bufSize );
		strncat(buf, "\r\ndir=", bufSize );
		strncat(buf, dir,  bufSize );

		if( !WriteFile( hFile, buf, strlen(buf), &nWritten,	NULL ) ) {
			AfxMessageBox("Error writing to file");
			CloseHandle(hFile);
			return;
		}

		CloseHandle(hFile);		
	}
}

void CNSServGUIDlg::OnChangeEditKey() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	change = true;
	m_btnApply->EnableWindow(1);
	
}

void CNSServGUIDlg::OnChangeEditPort() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	change = true;
	m_btnApply->EnableWindow(1);
	
}

void CNSServGUIDlg::GetServiceConfig()
{
	SC_HANDLE				schService;
    SC_HANDLE				schSCManager;	
	DWORD					dwBytesNeeded; 
	LPQUERY_SERVICE_CONFIG  m_lpqscBuf=NULL;

    schSCManager = OpenSCManager( NULL,						// machine (NULL == local)
								  NULL,						// database (NULL == default)
								  SC_MANAGER_ALL_ACCESS );  // access required
								 
    if ( schSCManager ) {
		
		// Open a handle to the service. 
 
		schService = OpenService( 
			schSCManager,           // SCManager database 
			TEXT(SZSERVICENAME),    // name of service 
			SERVICE_QUERY_CONFIG);  // need QUERY access 
		
		if (schService == NULL) {
			LastErrorMsgBox(); 
			goto cleanup;
		}  
		
		// Get number of bytes needed

		QueryServiceConfig( schService, m_lpqscBuf, 0, &dwBytesNeeded);		
		
		// Allocate buffer

		m_lpqscBuf = new QUERY_SERVICE_CONFIG[dwBytesNeeded];
		
		// Get the information configuration.

		if ( QueryServiceConfig( schService, m_lpqscBuf, dwBytesNeeded, &dwBytesNeeded)) {
			
			// get startup type

			switch(m_lpqscBuf->dwStartType)
			{
			case SERVICE_DEMAND_START:
				m_startupType = 0;
				break;
			case SERVICE_AUTO_START:
				m_startupType = 1;
				break;
			case SERVICE_DISABLED:		
				m_startupType = 2;
				break;
			}			
		}
		else
			LastErrorMsgBox();
	}

cleanup:
	if(schSCManager != NULL)
		CloseServiceHandle(schSCManager);
	if(schService != NULL)
		CloseServiceHandle(schService);
	if(m_lpqscBuf!=NULL)
		delete m_lpqscBuf;
}

void CNSServGUIDlg::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	
	SetStartupType(SERVICE_DEMAND_START);
	m_startupType=0;
	UpdateControls();
}

void CNSServGUIDlg::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	
	SetStartupType(SERVICE_AUTO_START);
	m_startupType=1;
	UpdateControls();
		
}

void CNSServGUIDlg::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	
	SetStartupType(SERVICE_DISABLED);
	m_startupType=2;
	UpdateControls();	
}

void CNSServGUIDlg::SetStartupType(DWORD dwStartType)
{
	SC_LOCK		sclLock;     
	SC_HANDLE	schService;
    SC_HANDLE	schSCManager;	
	
    schSCManager = OpenSCManager( NULL,						// machine (NULL == local)
								  NULL,						// database (NULL == default)
								  SC_MANAGER_ALL_ACCESS );  // access required
								 
    if ( schSCManager ) {
 
		// Need to acquire database lock before reconfiguring. 
 
		sclLock = LockServiceDatabase(schSCManager); 
 
		// If the database cannot be locked, report the details. 
 
		if (sclLock == NULL) { 
			LastErrorMsgBox(); 
			goto cleanup;
		}			
 
		// The database is locked, so it is safe to make changes. 
 
		// Open a handle to the service.
		
		schService = OpenService( schSCManager,           // SCManager database 
								  TEXT(SZSERVICENAME),    // name of service 
								  SERVICE_CHANGE_CONFIG); // need CHANGE access 
		
		if (schService == NULL) {
			LastErrorMsgBox(); 
			goto cleanup;
		}
 
		// Change congiuration data
 
		if ( !ChangeServiceConfig( schService,        // handle of service 
								   SERVICE_NO_CHANGE, // service type: no change 
								   dwStartType,       // change service start type 
								   SERVICE_NO_CHANGE, // error control: no change 
								   NULL,              // binary path: no change 
								   NULL,              // load order group: no change 
								   NULL,              // tag ID: no change 
								   NULL,              // dependencies: no change 
								   NULL,              // account name: no change 
								   NULL,			  // password: no change 
								   NULL ))           // display name: no change
		{
			LastErrorMsgBox(); 
			goto cleanup;
		}		
	}
		
cleanup:
	// Release the database lock. 
	if(sclLock != NULL)
		UnlockServiceDatabase(sclLock); 
	// Close the handle to the service. 
	if(sclLock != NULL) 
		CloseServiceHandle(schService);
	if(sclLock != NULL) 
		CloseServiceHandle(schSCManager);
}

BOOL CNSServGUIDlg::CheckFiles()
{	
	char		files[1000];
	bool		ret=true;
	char*		dir=0;	
	DWORD		dirlen;
	DWORD		version;
	DWORD		majorVersion;

	dirlen = GetCurrentDirectory(0, dir);
	dir = new char[dirlen];
	
	if(GetCurrentDirectory(dirlen, dir)==0) 		
		::MessageBox( NULL, "Error reading directory", SZSERVMANNAME, MB_OK | MB_ICONERROR);
	else {	
		strncpy(files, "Files not found:\n\n", 1000);
		
		// Check if the service-file exists
		if( GetFileAttributes(SZAPPNAME) == 0xFFFFFFFF) {
			strncat(files, dir, 10000);
			strncat(files, "\\", 10000);
			strncat(files, SZAPPNAME, 10000);
			strncat(files, "\n", 10000);
			ret=false;
		}		
		
		if( GetFileAttributes(PROSLISTFILE) == 0xFFFFFFFF) {
			strncat(files, dir, 10000);
			strncat(files, "\\", 10000);
			strncat(files, PROSLISTFILE, 10000);
			strncat(files, "\n", 10000);
			ret=false;
		}
		
	
		// get Windows-version
		version = GetVersion();
		majorVersion = (DWORD) (LOBYTE(LOWORD(version)));
		
	
		if( GetFileAttributes("pdh.dll") == 0xFFFFFFFF && majorVersion<5) {
			strncat(files, dir, 10000);
			strncat(files, "\\", 10000);
			strncat(files, "pdh.dll", 10000);
			ret=false;
		}
	}
	if(!ret)
		::MessageBox( NULL, files, SZSERVMANNAME, MB_OK | MB_ICONERROR | MB_TASKMODAL);
		
	delete dir;
	return ret;
}


void CNSServGUIDlg::UpdateControls()
{
	if(isInstalled) {

		m_btnInstall->EnableWindow(0);
		m_btnRemove->EnableWindow(1);
		m_btnAutomatic->EnableWindow(1);
		m_btnManual->EnableWindow(1);
		m_btnDisable->EnableWindow(1);
		
		
			
		switch(status.dwCurrentState) 
		{
		case SERVICE_STOPPED:
			m_szStatus="Stopped";
			m_btnStart->EnableWindow(1);
			m_btnStop->EnableWindow(0);
			m_btnPause->EnableWindow(0);
			m_btnContinue->EnableWindow(0);		
			break;
		case SERVICE_STOP_PENDING:
			m_szStatus="Stop pending";
			m_btnStart->EnableWindow(1);
			m_btnStop->EnableWindow(0);
			m_btnPause->EnableWindow(0);
			m_btnContinue->EnableWindow(0);	
			break;
		case SERVICE_RUNNING:
			m_szStatus="Running";
			m_btnStart->EnableWindow(0);
			m_btnStop->EnableWindow(1);
			m_btnPause->EnableWindow(1);
			m_btnContinue->EnableWindow(0);	
			break;
		case SERVICE_START_PENDING:
			m_szStatus="Running";
			m_btnStart->EnableWindow(0);
			m_btnStop->EnableWindow(1);
			m_btnPause->EnableWindow(1);
			m_btnContinue->EnableWindow(0);	
			break;
		case SERVICE_PAUSED:
			m_szStatus="Paused";
			m_btnStart->EnableWindow(0);
			m_btnStop->EnableWindow(1);
			m_btnPause->EnableWindow(0);
			m_btnContinue->EnableWindow(1);	
			break;
		case SERVICE_PAUSE_PENDING:
			m_szStatus="Pause pending";
			break;
		case SERVICE_CONTINUE_PENDING:
			m_szStatus="Continue pending";
			break;
		}	
	}
	else { // not installed
		m_szStatus="Not installed";
		m_btnInstall->EnableWindow(1);
		m_btnRemove->EnableWindow(0);		
		m_btnStart->EnableWindow(0);
		m_btnStop->EnableWindow(0);
		m_btnPause->EnableWindow(0);
		m_btnContinue->EnableWindow(0);
		m_btnAutomatic->EnableWindow(0);
		m_btnManual->EnableWindow(0);
		m_btnDisable->EnableWindow(0);
	}	

	UpdateData(0);
}

void CNSServGUIDlg::OnKillfocusEditPort() 
{
	// TODO: Add your control notification handler code here
	if(!exit)
		UpdateData(1);
}

void CNSServGUIDlg::OnKillfocusEditKey() 
{
	// TODO: Add your control notification handler code here
	if(!exit)
		UpdateData(1);	
}
