#include "Thread.h"
#include "Common.h"

DWORD WINAPI CheckServiceStatus(LPVOID lpvParam) {

	CWnd *pGUI = (CWnd *) lpvParam;

	SC_HANDLE			schService;
    SC_HANDLE			schSCManager;
	SERVICE_STATUS		ssStatus;
	DWORD				dwRet;

	schSCManager = OpenSCManager( NULL,				// machine (NULL == local)
								  NULL,				// database (NULL == default)
								  GENERIC_READ );	// access required
		
	if ( schSCManager ) {	
		schService = OpenService( schSCManager,			// SCM database 
								  TEXT(SZSERVICENAME),  // service name
								  SERVICE_QUERY_STATUS );
				
		if (schService == NULL)  {
			ChkStatThrd=false;
			if( GetLastError() != ERROR_SERVICE_DOES_NOT_EXIST )			
				LastErrorMsgBox();			
		}
		else {	
			ChkStatThrd=true;
			isInstalled=true;
			thrdIsRunning=true;
			status.dwCurrentState = 0;
			ResetEvent(hChkStatThrdEvent);	// OBS!
		}

		while(ChkStatThrd) {	 
			if (!QueryServiceStatus( schService,   // handle to service 
									 &ssStatus) ) { // address of status information
				
				LastErrorMsgBox();				
				Sleep(500);
				continue;			
			}
			
			// Status changed, update
			if( ssStatus.dwCurrentState != status.dwCurrentState ) {
				status.dwCurrentState = ssStatus.dwCurrentState;
				::PostMessage( pGUI->m_hWnd, WM_STATUS_CHANGED, 0, 0 );
			}			
			
			//Sleep(500);
			dwRet = WaitForSingleObject(hChkStatThrdEvent, 500);
		}
	}
	else
		LastErrorMsgBox();
	

	if(schSCManager != NULL)
		CloseServiceHandle(schSCManager);
	if(schService != NULL)
		CloseServiceHandle(schService);	
	
	//Fortell at vi har avsluttet
	SetEvent(hChkStatThrdEvent);
	thrdIsRunning=false;
	return 0;
}